.ifdef CMDDLIST
DLIST:
    CMP #$23     ; Hash of DLIST
    BNE ENDDLIST ; if not try other letter
    LDA #$01     ; filename length
    TAX
    LDY #$E8     ; there is a "$" at $E801 in ROM
    JSR $FFBD    ; set filename, A=namelen, XY=address of name
    LDA #$60
    STA $B9      ; set secondary address
    JSR $F3D5    ; send secondary address and filename
    JSR $F219    ; set default input device
    LDY #$04     ; skip 4 bytes (load address and link pointer)
FISIZE:
    JSR $EE13    ; input a byte from the serial bus
    DEY
    BNE FISIZE   ; loop
    LDA $90      ; STATUS variable
    BNE ENDDIR   ; check end of file
    JSR $EE13    ; read byte from the serial bus (block count low)
    TAX          ; keep it
    JSR $EE13    ; read byte (block count high)
    JSR $BDCD    ; print XA as unsigned 16 bit integer
    LDA #$20     ; Space character
    JSR $FFD2    ; print character to stdout
FINAME:
    JSR $EE13    ; read character
    JSR $FFD2    ; print character to stdout
    BNE FINAME   ; loop until zero
    JSR $AAD7    ; print carriage return character
    LDY #$02
    BNE FISIZE   ; skip 2 bytes next time (link pointer)
ENDDIR:
    JSR $F642    ; CLOSE
    JSR $F6F3    ; reset default input device
    JMP $A7E4    ; Continue interpreting getting new character
ENDDLIST:
.endif

.ifdef CMDCGOTO
cgoto:                 ; CGOTO line (calculated GOTO)
    cmp #$0F           ; Hash of CGOTO low (2*$43+$89+0)
    bne endcgoto       ; if not try other letter
    jsr $0073          ; Scan for next symbol
    jsr $AD8A          ; Get Float parameter
    jsr $B7F7          ; Convert to 2 byte integer, Y=lo, A=HI
    sty $14            ; Area for GOTO command
    sta $15            ; Area for GOTO command
    jsr $A8A3          ; Execute GOTO 
    jmp $A7AE          ; jump to main interpreter loop
endcgoto:
.endif

.ifdef CMDBLANK
blankblank:
    CMP #$60     ; Hash of 2blanks
    bne endblankblank ; if not try other letter
    lda $02a9
    and #$01
    bne nextinstr
    LDY #$00    ;    clear the index
skipline:
    INC $7A    ;     increment BASIC execute pointer low byte
    BNE checkeoln;       branch if no carry
    INC $7B     ;    increment BASIC execute pointer high byte
checkeoln:
    LDA ($7A),Y ;    get a BASIC byte
    BNE skipline ;      if not [EOL] go test for ":"
    jmp $A7AE          ; jump to main interpreter loop to check new command      
nextinstr:
    JMP $A7E4    ; Continue interpreting getting new character

endblankblank:
.endif


.ifdef CMDIFTHEN
iif:
    CMP #$BE     ; Hash of IFTHEN
    bne endiif ; if not try other letter
    jsr $0073          ; Scan for next symbol
    jsr $AD8A  	       ; Get Float parameter
    lda $61
    CLC
    beq stuffcond
    sec
stuffcond:
    rol $02a9 
    jmp $A7AE          ; jump to main interpreter loop to check new command      
endiif:
.endif

.ifdef CMDIFEND
eendif:
    CMP #$97    ; Hash of ifend
    bne endendif ; if not try other letter
    lsr $02a9
    JMP $A7E4    ; Continue interpreting getting new character
endendif:
.endif

.ifdef CMDIFNOT
ifnot:
    CMP #$BF    ; Hash of ifnot
    bne endifnot ; if not try other letter
    lda $02a9
    eor #$01
    sta $02a9
    JMP $A7E4    ; Continue interpreting getting new character
endifnot:
.endif

